const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ai_captions = sequelize.define(
    'ai_captions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

caption_text: {
        type: DataTypes.TEXT,
      
      

      },

confidence: {
        type: DataTypes.DECIMAL,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"generated",


"edited",


"approved",


"rejected"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ai_captions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









































//end loop



    db.ai_captions.belongsTo(db.media_items, {
      as: 'media_item',
      foreignKey: {
        name: 'media_itemId',
      },
      constraints: false,
    });

    db.ai_captions.belongsTo(db.ai_models, {
      as: 'ai_model',
      foreignKey: {
        name: 'ai_modelId',
      },
      constraints: false,
    });

    db.ai_captions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.ai_captions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ai_captions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ai_captions;
};


